Attribute VB_Name = "MainModule"
Option Explicit

Public Window As WindowClass

Public LightImage As ImageClass

Const Size = 100

Public MidX As Long
Public MidY As Long

Public Sub Main()
    MsgBox "OGE2 VB engine demo.  Email: mjennings80@hotmail.com  ICQ: 3565855"
    InitializeOGE2
    
    Set LightImage = New ImageClass
    LightImage.Import LoadPCKFile(App.Path & "\LightMap.Bmp")
    
    LightImage.OriginX = LightImage.Width / 2
    LightImage.OriginY = LightImage.Height / 2
    
    Dim LogoImage As New ImageClass
    LogoImage.Import LoadPCKFile(App.Path & "\Logo1.Bmp")
    
    LogoImage.OriginX = LogoImage.Width / 2
    LogoImage.OriginY = LogoImage.Height / 2
    
    Set Window = New WindowClass
    Window.Caption = "Powered by OGE2"
    Window.Width = 320
    Window.Height = 200
    Window.WindowMode = WM_WINDOWED
    Window.Center
    Window.Visible = True
    
    MidX = Window.Width / 2
    MidY = Window.Height / 2
    
    Dim MainBody As New BodyClass
    
    Dim I As Long, X As Single, Y As Single, Z As Single
    For I = 1 To 50
        AddBody MainBody, Int(200 * Rnd) - 100, Int(200 * Rnd) - 100, Int(200 * Rnd) - 100
    Next I
    
    MainBody.ApplyRelativeTransform
    
    Dim CurFrame As Single
    Do Until Window.Keyboard.KeyState(vbKeyEscape) = True
        CurFrame = CurFrame + 0.1
        RenderChildren MainBody
        LogoImage.Blt MidX, MidY, Window.Backbuffer, True, Int((Sin(CurFrame) * 127) + 127)
        Window.Refresh
        
        Window.Backbuffer.Brighten -64
        DoEvents
        
        MainBody.RelativeOrientation.Pitch = MainBody.RelativeOrientation.Pitch + (1.3 * 4)
        MainBody.RelativeOrientation.Yaw = MainBody.RelativeOrientation.Yaw + (1.3 * 4)
        MainBody.ApplyRelativeTransform
        
        If Window.Mouse.ButtonState(vbLeftButton) = True Then
            Window.Mouse.ButtonState(vbLeftButton) = False
            If Window.WindowMode = WM_FULLSCREEN Then
                Window.WindowMode = WM_WINDOWED
            Else
               Window.WindowMode = WM_FULLSCREEN
            End If
        End If
    Loop
    
    Window.Visible = False
    
    Set Window = Nothing
    Set LightImage = Nothing
    Set LogoImage = Nothing
    
    ShutdownOGE2
End Sub

Public Sub RenderChildren(ByRef Body)
    Dim I As Long
    For I = 1 To Body.Children.Count
        Render Body.Child(I)
    Next I
End Sub

Public Sub Render(ByRef Body As BodyClass)
    Dim I As Long, X As Single, Y As Single, Z As Single
    Body.GlobalPosition.GetProperties X, Y, Z
    Z = (Z + 250) / 5
    X = ((X / Z) * 25) + MidX
    Y = ((Y / Z) * 25) + MidY
    LightImage.LightMapBlt X, Y, Window.Backbuffer, True, LMM_NORMAL
    For I = 1 To Body.Children.Count
        Render Body.Child(I)
    Next I
End Sub

Public Sub AddBody(ByRef Body As BodyClass, ByRef X As Single, ByRef Y As Single, ByRef Z As Single)
    Dim tempbody As New BodyClass
    Body.AddChild tempbody
    tempbody.RelativePosition.SetProperties X, Y, Z
    tempbody.ApplyRelativeTransform
End Sub
